// WriteRemoteFile.h: interface for the CRemoteFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REMOTEFILE_H__3EF3E462_FD92_11D3_A827_444553540000__INCLUDED_)
#define AFX_REMOTEFILE_H__3EF3E462_FD92_11D3_A827_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


//////////////////////////////////////////////////////////////////////
// Definitionen der Umlaute- und Dateiformate
enum umlautetyp
{
        umlautetyp_DOS = 0x00,// Umlaut nach DOS-Zeichensatz
        umlautetyp_WINDOWS = 0x01, // Umlaut nach WINDOWS-Zeichensatz
        umlautetyp_Std_sz = 0x02, // Umlaut systemunabhngig Ae, ae, ..., sz
        umlautetyp_Std_ss = 0x03, // Umlaut systemunabhngig Ae, ae, ..., ss
        umlautetyp_MAC_OS = 0x04, // Umlaut nach Macintosh-Zeichensatz
        umlautetyp_undefined = 0xff
};


//////////////////////////////////////////////////////////////////////
// Bei Fehlfunktion kann die Fehlermeldung mit Hilfe von
// GetLastError() ermittelt werden. Dabei werden folgende Fehlernummern
// von Windows verwendet :
//        ERROR_DISK_OPERATION_FAILED
//        ERROR_INVALID_PARAMETER
//        ERROR_OPEN_FAILED


class CRemoteFile  
{
public:
	CRemoteFile();
	virtual ~CRemoteFile();

public:
	// Funktionen zum Setzen der Werte :
	bool	SetNameAndRegKey(char * lpszName, char * lpszRegKey);
	bool	SetFileNames(char * lpszInFile, char * lpszOutFile);
	bool	SetWindowHandles(HWND hwndProgress, HWND hwndMessages);
	bool	SetFileTypes(umlautetyp utInFileType, umlautetyp utOutFileType);

	// Funktionen zur Dateibehandlung
	// Die Standard-Dateiendung fr UmlauteKonverter-RemoteFiles ist
	// '.urf'
	bool	WriteRemoteFile(const char * lpszFilename);


	// Daten, die Inhalt des Remote-Files sind
private:
	// Registrationsdaten
	char	* m_lpszName;
	char	* m_lpszRegKey;

	// Dateinamen
	char	* m_lpszInFile;
	char	* m_lpszOutFile;

	HWND	m_hwndProgress;
	HWND	m_hwndMessages;

	umlautetyp	m_utInFileType;
	umlautetyp	m_utOutFileType;
};

#endif // !defined(AFX_REMOTEFILE_H__3EF3E462_FD92_11D3_A827_444553540000__INCLUDED_)
