// UmlKonv_OLETest.cpp :
// Beispiel-Programm zur Nutzung von Umlaute-Konverter
// mittels OLE
//
// Vorgehensweise mit Microsoft Visual C++ 5.0:
// 1. Neues MFC-Projekt erstellen oder vorhandenes ffnen
// 2. Im Class-Wizard "Add Class...", dann "From a type library..."
//    whlen. Im Datei-Dialog die Datei "UmlauteKonverter.tlb"
//    ffnen. Voreinstellungen beibehalten.
//    Dem Projekt werden nun die Dateien "UmlauteKonverter.h" und
//    "UmlauteKonverter.cpp" hinzugefgt. In der ClassView erscheint
//    die Automation-Class "IUmlauteKonverter"
// 3. Dann kann der Source-Code, wie in dieser Datei gezeigt,
//    angepasst werden:



#include "stdafx.h"
#include "umlautekonverter.h" // Definition des OLE-Interface von UmlauteKonverter

#include "UmlKonv_OLETest.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// Konstanten fr die Arbeit mit Umlaute-Konverter:

#define umlautetyp_DOS			0x00 // Umlaut nach DOS-Zeichensatz
#define umlautetyp_WINDOWS		0x01 // Umlaut nach WINDOWS-Zeichensatz
#define umlautetyp_Std_sz		0x02 // Umlaut systemunabhngig Ae, ae, ..., sz
#define umlautetyp_Std_ss		0x03 // Umlaut systemunabhngig Ae, ae, ..., ss
#define umlautetyp_MAC_OS		0x04 // Umlaut nach Macintosh-Zeichensatz
#define umlautetyp_undefined	0xff



/////////////////////////////////////////////////////////////////////////////
// COLETestApp

BEGIN_MESSAGE_MAP(COLETestApp, CWinApp)
	//{{AFX_MSG_MAP(COLETestApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// The one and only COLETestApp object

COLETestApp theApp;

/////////////////////////////////////////////////////////////////////////////
// COLETestApp initialization

BOOL COLETestApp::InitInstance()
{
	// Initialisiere OLE
	if ( !AfxOleInit() )
	{
		AfxMessageBox("FEHLER: Initialisierung von OLE fehlgeschlagen !");
		return FALSE;
	}

	// OLE-Objekt von UmlauteKonverter erzeugen
	IUmlauteKonverter	autoUmlKonv;

	// OLE-Verbindung herstellen
	if (!autoUmlKonv.CreateDispatch(_T("UmlauteKonverter.Application")))
	{
		AfxMessageBox("FEHLER: Kein Zugriff auf UmlauteKonverter. Bitte installieren Sie UmlauteKonverter und starten es einmalig zwecks OLE-Registrierung.");
		return FALSE;
	}
	else
		AfxMessageBox("UmlauteKonverter erfolgreich gestartet !");


	// Nun kann mit UmlauteKonverter gearbeitet werden:
	CString	cstrName = "";
	CString	cstrRegKey = "";
	char	szSrcText[] = "Die Groesze von Umlaute-Konverter liegt darin, auch Saetze wie 'Sueszes ist oft teuerer als Saueres' korrekt umzuwandeln.";

	// Mit der Autodetect-Funktion kann das Format des Beispieltextes
	// ermittelt werden. Der Ergebnis-String beinhaltet eine Statistik
	// ber die Hufigkeit der auftretenden Umlaute:
	CString	cstrResult;
	cstrResult = "Die Autodetect-Funktion liefert fr den String \n\"";
	cstrResult+= szSrcText;
	cstrResult+= "\"\nfolgendes Ergebnis:\n\n";
	cstrResult+=
		autoUmlKonv.AutodetectTextType(cstrName, cstrRegKey,
									   szSrcText, sizeof(szSrcText));
	// Ergebnis ausgeben:
	AfxMessageBox(cstrResult);

	// Mit der ConvertText-Funktion werden die Umlaute des Textes
	// umgewandelt. Hier erfolgt die Konvertierung von UNDEFINED
	// (Das heit, UmlauteKonverter ermittelt das Format des
	// Textes selbststndig) zu WINDOWS
	cstrResult = "Der String \n\"";
	cstrResult+= szSrcText;
	cstrResult+= "\"\numgewandelt zu Windows-Umlauten ergibt:\n\n";
	cstrResult+=
		autoUmlKonv.ConvertText(cstrName, cstrRegKey,
								szSrcText, sizeof(szSrcText),
								umlautetyp_undefined, umlautetyp_WINDOWS);
	// Ergebnis ausgeben:
	AfxMessageBox(cstrResult);

	// Die Freigabe von UmlauteKonverter erfolgt automatisch im Destruktor
	//  von autoUmlKonv.

	return FALSE; // Applikation beenden, keine Message-Bearbeitung anschlieen
}
